local data = {
	title = 'Watcher',
	addresses = {},
	field = '',
	type = 0
}

local sizes = {
	"4 bytes (hex)",
	"2 bytes (hex)",
	"1 byte  (hex)",
	"4 bytes (dec)",
	"2 bytes (dec)",
	"1 byte  (dec)",
	"float"
}

local mem_fun = {
	memory.read_u32,
	memory.read_u16,
	memory.read_u8,
	memory.read_u32,
	memory.read_u16,
	memory.read_u8,
	memory.read_f32
}

function data.draw()
	data.field = imgui.hex("addr:", data.field)

	data.type = imgui.combo("size", sizes, data.type)
	imgui.sameline()
	if imgui.button("Add") then
		table.insert(data.addresses, {
			type = data.type,
			addr = tonumber(data.field, 16)
		})
	end
	for _, d in ipairs(data.addresses) do
		local s

		if d.type < 3 then
			s = "0x%x"
		elseif d.type < 6 then
			s = "%d"
		else
			s = "%f"
		end

		local v = mem_fun[d.type + 1](d.addr)
		imgui.text(string.format("0x%x: " ~ s, d.addr, v))
	end
end

return data
